/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2015 Verchenko Andrey <verchenkoag@gmail.com>
 * Copyright 2015 Grigory Filatov <gfilatov@inbox.ru>
*/

#include "minigui.ch"
#include "excel.ch"
#include "metrocolor.ch"

///////////////////////////////////////////////////////////////////////////////////////////
//    Excel
FUNCTION IsExcelFound()
   LOCAL oExcel, cMsg

   oExcel := TOleAuto():NEW( "Excel.Application" )
   IF Ole2TxtError() != 'S_OK'
      cMsg := REPLICATE( "-._.", 16 ) + ";;"
      cMsg += SPACE( 10 ) + "   Excel   !;;"
      cMsg += REPLICATE( "-._.", 16 ) + ";;"
      cMsg := AtRepl( ";", cMsg, CRLF )
      MsgStop( cMsg , "!" )
      RETURN .F.
   ENDIF
   oExcel:Quit()

   RETURN .T.

///////////////////////////////////////////////////////////////////////////////////////////
//   Excel
FUNCTION MyExcelVersion()
   LOCAL oExcel, nVer, aDim[20]

   AFILL(aDim,"???")
   aDim[01] := " Excel   !"
   aDim[09] := "Excel 2000"
   aDim[10] := "Excel XP"
   aDim[11] := "Excel 2003"
   aDim[12] := "Excel 2007"
   aDim[14] := "Excel 2010"
   aDim[15] := "Excel 2013"
   aDim[16] := "Excel 2014"
   aDim[17] := "Excel NEW!"

   oExcel := TOleAuto():NEW( "Excel.Application" )
   IF Ole2TxtError() != 'S_OK'
      nVer := 1
   ELSE
      oExcel := CreateObject( "Excel.Application" )
      oExcel:DisplayAlerts := .F.
      oExcel:visible := .F.
      nVer := VAL( oExcel:Version )
      oExcel:Quit()
   ENDIF

   //Ob:= win_oleCreateObject("Scripting.FileSystemObject")
   //? Ob:GetFileVersion(  EXCEL+"excel.exe")

   /*
   http://clipper.borda.ru/?1-4-0-00000749-000-10001-0
   Dima -  N: 4662
    OLocator:=CreateObject("wbemScripting.SwbemLocator") 
    oWMI:= oLocator:ConnectServer() 
    arr:=oWMI:ExecQuery("SELECT * FROM Win32_Product") 
         for each oitem in arr 
            if hb_at("Microsoft Office",oitem:Name)>0 
                  if hb_at("2003",oitem:Name)>0 
                     ? 2003 
                  elseif hb_at("2007",oitem:Name)>0 
                     ? 2007 
                  elseif hb_at("2010",oitem:Name)>0 
                     ? 2010 
                  endif  
            endif 
         next 
   */  
   RETURN { nVer, aDim[INT(nVer)] }

///////////////////////////////////////////////////////////////////////////////////////////
//    Excel
// http://clipper.borda.ru/?1-20-0-00000371-000-0-0-1195742832
// Pasha -  N: 645
FUNCTION MyExcelPath()
 LOCAL cPath := NIL 
 cPath := win_regRead( "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\excel.exe\Path" )
Return cPath



