/*
 * MINIGUI - Harbour Win32 GUI library  
 *
 * Copyright 2017 Verchenko Andrey <verchenkoag@gmail.com>
*/
#include "MiniGUI.ch"
#include "excel.ch"

//////////////////////////////////////////////////////////////////////
//    
FUNCTION ConvertXLS(cFileXls,cPath)
   LOCAL cText, aRezult := {}, cTitle := "  XLS  CSV"
   LOCAL cFileCsv := SUBSTR( cFileXls,1,RAT(".",cFileXls)) + "csv"  
   LOCAL nWidth, nHeight 

   DEFINE WINDOW Win_Cnvrt ;
          Row 0 Col 0 ;
          WIDTH 455 HEIGHT 350 ;
          TITLE cTitle ;
          ICON "1MAIN_ICO" ;
          WINDOWTYPE CHILD ;
          NOSIZE NOMAXIMIZE NOMINIMIZE ;
          FONT 'Tahoma' SIZE 12        ;
          ON INIT {|| StartConvertCsv(@aRezult,cFileXls,cPath,cFileCsv), Win_Cnvrt.Release() }

       nWidth  := This.ClientWidth   
       nHeight := This.ClientHeight  

       @ 5, 80 ANIMATEBOX Avi_1 WIDTH 32 HEIGHT 40  ;
          File 'AVIXLS' AUTOPLAY TRANSPARENT NOBORDER

       @ 77, 20 LABEL Status1  WIDTH 440 HEIGHT 20 ;
          VALUE ' : ' + cFileXls 

       cText := '     !' + CRLF
       cText += ':   7-    !' + CRLF
       @ 100, 20 LABEL Label_1 WIDTH 440 HEIGHT 20*3 ;
          VALUE cText  

       @ nHeight-90-20, 20 LABEL Status2  ;
          WIDTH 440 HEIGHT 20 ;
          VALUE ' : ' + cFileCsv       

       @ nHeight-90, 20 PROGRESSBAR Bar_2 RANGE 0, 100  VALUE 0 ;
          WIDTH 410 HEIGHT 34 

   END WINDOW

   Win_Cnvrt.Center
   Win_Cnvrt.Activate

   RETURN aRezult

//////////////////////////////////////////////////////////////////////
FUNCTION StartConvertCsv(aRezult,cFileXls,cPath,cFileCsv)
   LOCAL lStep1, aStep2 := {}

   //  1
   lStep1 := XlstoCsv(cFileXls,cPath,cFileCsv)

   IF lStep1
      //  2
      aStep2 := ProcessingCsv(cPath,cFileCsv,cFileXls)
   ENDIF

   aRezult := aStep2  //   
   
   RETURN aStep2 

//////////////////////////////////////////////////////////////////////
FUNCTION XlstoCsv(cFileXls,cPath,cFileCsv)
   LOCAL lRet := .F., cMsg, oExcel, nErr, oBook
   LOCAL cFileName := cPath + "\" + cFileXls
   LOCAL cFileSave := cPath + "\" + cFileCsv

   IF ! IsExcelFound()  //   EXCEL   
      RETURN lRet
   ENDIF

   //oExcel := win_oleCreateObject("Excel.Application") 
   oExcel := TOleAuto():New( "Excel.Application" )
   oExcel:Visible := .F.         //   EXCEL
   oExcel:DisplayAlerts := .F.   //    
   oExcel:Workbooks:Open( cFileName, 0 )
   //oSheet := oExcel:ActiveSheet()
   oBook := oExcel:ActiveWorkBook() 

   IF FILE( cFileSave )
     //  Excel     "   "  .  
     nErr := DELETEFILE(cFileSave)
     IF nErr == 0
        cMsg := " : " + ProcName( 0 ) + "(" + hb_ntos( ProcLine( 0 ) ) + ") --> " + ProcFile( 0 ) 
        //? cMsg
        //? 'oBook:SaveAs("'+cFileSave+'")' //   _MsgLog.txt
        oBook:SaveAs( cFileSave, xlCSV )  // xlCSV - #include "excel.ch"
        lRet := .T.
     ELSE
        cMsg := REPLICATE( "-._.", 16 ) + ";;"
        cMsg += "  : "+cFileSave+" !; : "+HB_NtoS(nErr)+";;"
        cMsg += "      !;;"
        cMsg += REPLICATE( "-._.", 16 ) + ";;"
        cMsg := AtRepl( ";", cMsg, CRLF )
        MsgStop( cMsg , "!" )
        lRet := .F.
     ENDIF
   ELSE
      cMsg := " : " + ProcName( 0 ) + "(" + hb_ntos( ProcLine( 0 ) ) + ") --> " + ProcFile( 0 ) 
      //? cMsg
      //? 'oBook:SaveAs("'+cFileSave+'")' //   _MsgLog.txt
      oBook:SaveAs( cFileSave, xlCSV )  // xlCSV - #include "excel.ch"
      lRet := .T.
   ENDIF

   oExcel:Quit()

   RETURN lRet

//////////////////////////////////////////////////////////////////////
FUNCTION ProcessingCsv(cPath,cFileCsv,cFileXls)
   LOCAL aRet := {} , cFile, cTitle, cMsg, cStr, nRecno 
   LOCAL cBuff, nI, nJ, aDim, aVal, nSum

   cTitle := Win_Cnvrt.Status2.Value  

   cFile := cPath + "\" + cFileCsv
   cBuff := HB_MemoRead(cFile)             //    
   aDim := HB_ATokens(cBuff,CRLF,.F.,.F.)  //     

   //  -  
   nJ := 0
   FOR nI := 1 TO LEN(aDim)
       aVal := HB_ATokens(aDim[nI],";",.F.,.F.)  //    

       IF CTOD(aVal[1]) == CTOD("")  //   =  - DD.MM.YYYY
          nJ++
       ELSE
          EXIT  
       ENDIF
   NEXT

   IF nJ == LEN(aDim)  //   1-    
      cMsg := REPLICATE( "-._.", 16 ) + ";;"
      cMsg += ":  " + cFileXls + "  -   !;;"
      cMsg += "   :;;"
      cMsg += "1- = ;"
      cMsg += "2- = /;"
      cMsg += "3- =  ;"
      cMsg += "4- =  ;"
      cMsg += "5- =  ;"
      cMsg += "6- =  ;"
      cMsg += "7- =  ;;"
      cMsg += REPLICATE( "-._.", 16 ) + ";;"
      cMsg := AtRepl( ";", cMsg, CRLF )
      MsgStop( cMsg , "!" )
      nJ := 1
   ELSE
      nJ++ //       +1
   ENDIF

   Win_Cnvrt.Bar_2.RangeMin := nJ         // MIN 
   Win_Cnvrt.Bar_2.RangeMax := LEN(aDim)  // MAX 

   cBuff := "" ; nSum := 0  ; nRecno := 0
   FOR nI := nJ TO LEN(aDim)

       Win_Cnvrt.Bar_2.Value := nI
       IF nI%5 == 0  //    5  
          Win_Cnvrt.Status2.Value := cTitle + SPACE(10) + HB_NtoS( INT( 100/LEN(aDim)*nI) ) + "%"
       ENDIF

       aVal := HB_ATokens(aDim[nI],";",.F.,.F.) //    

       IF LEN(aVal) > 0            //    
          IF LEN(aVal) >= 7        //   7- 
             cStr := aVal[7]
             cStr := CHARREPL(',',cStr,'.')
             nSum += VAL(cStr)    //  7- 
             nRecno++             //  - 
             cBuff += aDim[nI] + CRLF
          ENDIF
       ENDIF
       DO EVENTS // !     !
   NEXT
   Win_Cnvrt.Status2.Value := cTitle + SPACE(10) + "100%"
   DO EVENTS

   DELETEFILE( cFile )           //   
   HB_MemoWrit( cFile, cBuff )   //      

   cMsg := REPLICATE( "-._.", 16 ) + ";;"
   cMsg += "  :  " + cFileCsv + "  !;;"
   cMsg += "  = " + ALLTRIM( TRANSFORM(nRecno,"999 999 999") ) + ";;"
   cMsg += "  7-  = " + ALLTRIM( TRANSFORM(nSum,"999 999 999.99") ) + ";;"
   cMsg += "     !;;"
   cMsg += REPLICATE( "-._.", 16 ) + ";;"
   cMsg := AtRepl( ";", cMsg, CRLF )
   IF nSum == 0
      MsgStop( cMsg , "!" )
   ELSE
      MsgInfo( cMsg , "!" )
   ENDIF
   aRet := { cFileCsv, FileSize(cFile), FileDate(cFile) } //   
   ShellExecute(, "open", "notepad.exe", cFile,, 1 )

   RETURN aRet

//////////////////////////////////////////////////////////////////////
FUNCTION OpenXLSFile( cFileName )
   LOCAL oExcel, oSheet, hWnd

   IF ! IsExcelFound()  //   Excel  
      RETURN Nil
   ENDIF

   oExcel := TOleAuto():New( "Excel.Application" )
   oExcel:Visible := .T. // Show EXCEL
   oExcel:Workbooks:Open( cFileName, 0 )
   oSheet := oExcel:Get( "ActiveSheet" )

   //   Excel   
   hWnd := oExcel:hWnd
   ShowWindow( hWnd, 3 ) //SW_MAXIMIZE=3 SW_NORMAL=1 SW_MINIMIZE=6
   BringWindowToTop( hWnd )

   //    , ..    Excel
   // oExcel:Quit()

   RETURN Nil
