/*
 * MINIGUI - Harbour Win32 GUI library  
 * MiniGUI version 17.07 or higher
 *
 * Copyright 2017 Verchenko Andrey <verchenkoag@gmail.com>
 * Copyright 2017 Sergej Kiselev <bilance@bilance.lv>
*/
#include "MiniGUI.ch"
#include "TSBrowse.ch"
#include "metrocolor.ch"

MEMVAR oBrw1 

/////////////////////// Building TsBrowse  ////////////////////////////
FUNCTION MyTableXLS2CVS(nRow,nCol,nTblWidth,nTblHeight,aBColorTbr)
    
    PUBLIC oBrw1 

    SELECT DBMAIN
    goto TOP
    DEFINE TBROWSE oBrw1         ; 
           AT     nRow, nCol     ; 
           WIDTH  nTblWidth      ; 
           HEIGHT nTblHeight     ;
           BACKCOLOR aBColorTbr  ;
           CELL         

           //   / reate table
           MyCreateTable(aBColorTbr,'cTableName')

           // ------  oBrw1:cToolTip    --------
           //      ,   
           //   oBrw1, aRowPosRec -   
           __objAddData( oBrw1, 'aRowPosRec' ) 
           //    ,       TsBrowse
           oBrw1:aRowPosRec := Array(oBrw1:nRowCount()) 
           //    0
           AFill(oBrw1:aRowPosRec, 0)  
             
           //     .    . button
           oBrw1:bChange     := { |obr        | ChangeTable(obr)         }  
           oBrw1:bOnDrawLine := { |obr        | On_DrawLine(obr)         } 
           oBrw1:bOnDraw     := { |obr        | On_DrawSele(obr)         }  
           oBrw1:cToolTip    := { |obr,col,row| On_ToolTip (obr,col,row) } 
           // ------  oBrw1:cToolTip    --------

    END TBROWSE  
    //       
    oBrw1:SetNoHoles() 

    MyCreateTableMenu() //    

    RETURN NIL

////////////////////////////////////////////////////////////
FUNCTION MyCreateTable(aBColorTbr,cTableName)
    LOCAL cForm := ThisWindow.Name
    LOCAL hWnd := GetFormHandle( cForm )
    LOCAL hFont, nTxtWidth, nFontSize, aFontGet, aCursorBC, aColor
    LOCAL oCol, nBrw1Width, cStroka, aMarker[2], cAlias := Alias() 
    LOCAL nBackForm   := MyRGB( GetProperty(cForm, "Backcolor") )  //    
    LOCAL nBackTable  := MyRGB( aBColorTbr       )  //    
    LOCAL nHeadColor1 := MyRGB( GREEN            )  
    LOCAL nHeadColor2 := MyRGB( { 48,  29,  26 } )  // - 
    LOCAL aHeadColor  := YELLOW  // "__"
    LOCAL aFootColor  := YELLOW  // "__"
    LOCAL nIndexColor := MyRGB( COLOR_OF2016_GREEN ) //    
    LOCAL nColCount   := 0
    LOCAL nBCol, nBWidth, nWidth2, nTbrCol, nTbrWidth, aIndexCol
    DEFAULT aBColorTbr := GREEN , cTableName := "none"

    // --------------------     ------------------------------
    oBrw1:SetColor( { 1}, { { || CLR_BLACK                           } } ) // 1 ,                                  
    oBrw1:SetColor( { 2}, { { || /*CLR_WHITE*/ nBackTable            } } ) // 2 ,                                    
    oBrw1:SetColor( { 3}, { { || MyRGB(aHeadColor)                   } } ) // 3 ,                                     
    oBrw1:SetColor( { 4}, { { || { nHeadColor1, nHeadColor2 }        } } ) // 4 ,   
    oBrw1:SetColor( { 5}, { { || CLR_BLACK                           } } ) // 5 ,  ,                  
    oBrw1:SetColor( { 6}, { { || { 4915199,255}                      } } ) // 6 ,                                            
    oBrw1:SetColor( { 7}, { { || CLR_RED                             } } ) // 7 ,                               
    oBrw1:SetColor( { 8}, { { || CLR_YELLOW                          } } ) // 8 ,                                 
    oBrw1:SetColor( { 9}, { { || MyRGB(aFootColor)                   } } ) // 9 ,                                   
    oBrw1:SetColor( {10}, { { || { nHeadColor1, nHeadColor2 }        } } ) // 10,                                     
    oBrw1:SetColor( {11}, { { || CLR_GRAY                            } } ) // 11,    (selected cell no focused)
    oBrw1:SetColor( {12}, { { || { RGB(255,255,74), RGB(240,240,0) } } } ) // 12,    (selected cell no focused)   
    oBrw1:SetColor( {13}, { { || CLR_WHITE                           } } ) // 13,    
    oBrw1:SetColor( {14}, { { || { nIndexColor, nHeadColor1 }        } } ) // 14,      
    oBrw1:SetColor( {15}, { { || CLR_GRAY                            } } ) // 15,     
    oBrw1:SetColor( {16}, { { || {  CLR_WHITE, nHeadColor1 }         } } ) // 16,                                    
    oBrw1:SetColor( {17}, { { || CLR_RED                             } } ) // 17,  
    //  :  /   
    aMarker[ 1 ] := MyRGB(COLOR_LIGHT_RED) //Rgb( 163, 163, 163 )   //  15%
    aMarker[ 2 ] := Rgb( 127, 127, 127 )   //  25%          
    //     - specialselector header background color
    //oBrw1:nClrSelectorHdBack := CLR_HMAGENTA

    hFont := oBrw1:hFont         //     
    nFontSize := 10
    If hFont != Nil
       aFontGet := GetFontParam(hFont)
       nFontSize := aFontGet[2]  //      
    ENDIF

    //       
    nColCount  := 1
    nTxtWidth  := GetTextWidth( NIL, "00", hFont )  
    nBrw1Width := nTxtWidth  //    
     ADD COLUMN TO oBrw1 ;
         HEADER "" ;
         FOOTER  "("+HB_NtoS(nColCount)+")"  ;
         DATA {|| (cAlias)->( OrdKeyNo() ) } ;
         SIZE nTxtWidth PIXELS ;
         NAME NN               ;
         ALIGN DT_CENTER,DT_CENTER,DT_CENTER   // cells, header, footer

     //  2-  
     nColCount += 1
     cStroka   := IIF( GetDesktopWidth() == 800, REPLICATE("A", 18 ) , REPLICATE("A", 20 ) )
     nTxtWidth := GetTextWidth( NIL, cStroka, hFont ) 
     nBrw1Width += nTxtWidth                   //    
     ADD COLUMN TO oBrw1  ;
         HEADER  " "    ;   
         FOOTER  "("+HB_NtoS(nColCount)+")"    ;
         SIZE nTxtWidth                        ;
         ALIGN DT_LEFT,DT_CENTER,DT_CENTER     ;   // cells, header, footer
         DATA FIELDWBLOCK("FILE1", Select(cAlias)) ;
         PREEDIT      {|| FieldEditFile(), FALSE } ;
         NAME FILE1                                ;
         EDITABLE  

     //  3-  
     nColCount  += 1
     cStroka    := REPLICATE("0", 9 )
     nTxtWidth  := GetTextWidth( NIL, cStroka, hFont ) + 24
     nBrw1Width += nTxtWidth                   //    
     ADD COLUMN TO oBrw1 ;
         HEADER  ""        ;  
         FOOTER  "("+HB_NtoS(nColCount)+")"     ;
         SIZE nTxtWidth                         ;
         ALIGN DT_RIGHT,DT_CENTER,DT_CENTER     ;   // cells, header, footer
         DATA FIELDWBLOCK("SIZE1", Select(cAlias)) ;
         PREEDIT      {|| FieldEditFile(), FALSE } ;
         PICTURE "@Z 999 999 999"                  ;
         NAME SIZE1                                ;
         EDITABLE  
         
     //  4-  
     nColCount  += 1
     cStroka    := "99099099"
     nTxtWidth  := GetTextWidth( NIL, cStroka, hFont ) + 24
     nBrw1Width += nTxtWidth                    //    
     ADD COLUMN TO oBrw1 ;
         HEADER  ""          ;  // ""
         FOOTER  "("+HB_NtoS(nColCount)+")"     ;
         SIZE nTxtWidth                         ;
         ALIGN DT_CENTER,DT_CENTER,DT_CENTER    ;   // cells, header, footer
         DATA FIELDWBLOCK("DATE1", Select(cAlias)) ;
         PREEDIT      {|| FieldEditFile(), FALSE } ;
         PICTURE NIL                               ;
         NAME DATE1                                ;
         EDITABLE  

     //========================================================================
     //  5-    BITMAP,    CHECK  ()
     nColCount  += 1
     nTxtWidth  := 48*2
     nBrw1Width += nTxtWidth                     //    
     ADD COLUMN TO oBrw1  ;
         HEADER  ""     ;
         FOOTER  "("+HB_NtoS(nColCount)+")"  ;
         SIZE nTxtWidth   BITMAP             ;         // !!!
         COLOR CLR_BLACK, CLR_WHITE          ;
         ALIGN DT_CENTER,DT_CENTER,DT_CENTER ;         // cells, header, footer
         DATA FIELDWBLOCK("LCONV", Select(cAlias)) ;
         PREEDIT     {|| FieldImageEdit(), FALSE } ;
         NAME LCONV ;
         EDITABLE  
         oBrw1:aColumns[5]:bData    := {|| iif( (oBrw1:cAlias)->LCONV, 1, 2 )  }
         oBrw1:aColumns[5]:uBmpHead :=   LoadImage( "Image_Green" )  //  
         oBrw1:aColumns[5]:aBitMaps := { LoadImage( "Image_Green" ), LoadImage( "Image_Red" ) }

     // ========================================================================
     //  5-    CHECK,    BITMAP  ()
     /*nColCount  += 1
     nTxtWidth  := 48*2
     nBrw1Width += nTxtWidth                     //    
     ADD COLUMN TO oBrw1  ;
         HEADER  ""       ;
         FOOTER  "("+HB_NtoS(nColCount)+")"  ;
         SIZE nTxtWidth                      ;       // !!!
         COLOR CLR_BLACK, CLR_WHITE          ;
         ALIGN DT_CENTER,DT_CENTER,DT_CENTER ;       // cells, header, footer
         DATA FIELDWBLOCK("LCONV", Select(cAlias)) ;
         PREEDIT  {|| FieldImageEdit(), FALSE } ;
         CHECK ;                                     // !!!        
         NAME LCONV ;
         EDITABLE  
         oBrw1:aColumns[5]:uBmpHead  :=   LoadImage( "Image_Green" )  //  
         oBrw1:aColumns[5]:aCheck    := { LoadImage( "Image_Green" ), LoadImage( "Image_Red" ) }
      */

     //  6-  
     nColCount  += 1
     cStroka    := IIF( GetDesktopWidth() == 800, REPLICATE("A", 18 ) , REPLICATE("A", 20 ) )
     nTxtWidth  := GetTextWidth( NIL, cStroka, hFont ) // - nDelTsb 
     nBrw1Width += nTxtWidth                   //    
     ADD COLUMN TO oBrw1  ;
         HEADER  " "    ;   
         FOOTER  "("+HB_NtoS(nColCount)+")"    ;
         SIZE nTxtWidth                        ;
         ALIGN DT_LEFT,DT_CENTER,DT_CENTER     ;   // cells, header, footer
         DATA FIELDWBLOCK("FILE2", Select(cAlias)) ;
         PREEDIT      {|| FieldEditFile(), FALSE } ;
         NAME FILE2                                ;
         EDITABLE  

     //  7-  
     nColCount  += 1
     cStroka    := REPLICATE("9", 9 )
     nTxtWidth  := GetTextWidth( NIL, cStroka, hFont ) + 24
     nBrw1Width += nTxtWidth                   //    
     ADD COLUMN TO oBrw1  ;
         HEADER  ""        ;  
         FOOTER  "("+HB_NtoS(nColCount)+")"     ;
         SIZE nTxtWidth                         ;
         ALIGN DT_RIGHT,DT_CENTER,DT_CENTER     ;   // cells, header, footer
         DATA FIELDWBLOCK("SIZE2", Select(cAlias)) ;
         PREEDIT      {|| FieldEditFile(), FALSE } ;
         PICTURE "@Z 999 999 999"                  ;
         NAME SIZE2                                ;
         EDITABLE  
         
     //  8-  
     nColCount  += 1
     cStroka    := "99099099"
     nTxtWidth  := GetTextWidth( NIL, cStroka, hFont ) + 24 //   
     nBrw1Width += nTxtWidth                    //    
     ADD COLUMN TO oBrw1  ;
         HEADER  ""          ;  // ""
         FOOTER  "("+HB_NtoS(nColCount)+")"     ;
         SIZE nTxtWidth                         ;
         ALIGN DT_CENTER,DT_CENTER,DT_CENTER    ;   // cells, header, footer
         DATA FIELDWBLOCK("DATE2", Select(cAlias)) ;
         PREEDIT      {|| FieldEditFile(), FALSE } ;
         PICTURE NIL                               ; 
         NAME DATE2                                ;
         EDITABLE  

     //  9-  -  
     //       
     nColCount  += 1
     ADD COLUMN TO oBrw1 HEADER ""    ;
         DATA {|| NIL }               ;
         SIZE 0                       ;
         COLOR nBackTable, nBackTable ;
         NAME ZERO
         oBrw1:HideColumns( nColCount, .T. )     //  
         
     //oBrw1:lNoChangeOrd := .T.  //     
     //oBrw1:nColOrder := 0       //     
     oBrw1:lNoChangeOrd := .F.  //   
     oBrw1:nColOrder := 2       //     

     // ----------   \   6,7,8,9  ------------
     oBrw1:aColumns[ 2 ]:cOrder := OrdName(1)
     oBrw1:aColumns[ 3 ]:cOrder := OrdName(2)
     oBrw1:aColumns[ 4 ]:cOrder := OrdName(3)
     oBrw1:aColumns[ 6 ]:cOrder := OrdName(4)
     oBrw1:aColumns[ 7 ]:cOrder := OrdName(5)
     oBrw1:aColumns[ 8 ]:cOrder := OrdName(6)
     aIndexCol := { 2, 3, 4, 6, 7, 8 } 
     oBrw1:SetIndexCols( aIndexCol )    //    5    !!!

     // ----------         ------------
     oBrw1:aColumns[2]:nHAlign := {|nCol,oBrw| If( nCol == oBrw:nColOrder, DT_LEFT, DT_CENTER ) } 
     oBrw1:aColumns[3]:nHAlign := {|nCol,oBrw| If( nCol == oBrw:nColOrder, DT_LEFT, DT_CENTER ) } 
     oBrw1:aColumns[4]:nHAlign := {|nCol,oBrw| If( nCol == oBrw:nColOrder, DT_LEFT, DT_CENTER ) } 
     oBrw1:aColumns[6]:nHAlign := {|nCol,oBrw| If( nCol == oBrw:nColOrder, DT_LEFT, DT_CENTER ) } 
     oBrw1:aColumns[7]:nHAlign := {|nCol,oBrw| If( nCol == oBrw:nColOrder, DT_LEFT, DT_CENTER ) } 
     oBrw1:aColumns[8]:nHAlign := {|nCol,oBrw| If( nCol == oBrw:nColOrder, DT_LEFT, DT_CENTER ) } 

     // ---------        ---------
     oBrw1:aSortBmp := { LoadImage("Arrow_up"), LoadImage("Arrow_down") }

     //oBrw1:lCellBrw := .F.     // Marker on the entire table

     // -------- Fixed cursor , .  -------  "."   -----
     AEval(oBrw1:aColumns, {|oc| oc:lFixLite := .T., oc:lEmptyValToChar := .T. }) 

     //  :  /   
     //oCol:SaveColor()
     oCol := oBrw1:aColumns[ 1 ]
     aColor := oCol:aColorsBack
     aCursorBC := { 4915199,255}
     oBrw1:SetColor( { 6 }, { { |a,b,c| a:=NIL, IF( c:nCell == b, aCursorBC ,;  
                                  { aMarker[1], aMarker[2] })  }   } )            

     // MiniGUI version 17.07 or higher
     oBrw1:lNoKeyChar := .T.   //   : edit    \ 

     oBrw1:lPickerMode := .F.    //        

     oBrw1:lNoGrayBar  := .f.    //   
     //oBrw1:nAdjColumn  := 6      //        

     oBrw1:nHeightCell := 32 + 2*2   //    =   + 4
  
     //oBrw1:nHeightSuper := 60 + 3*2  //   (  )
  
     oBrw1:nHeightHead := 30 + 2*2   //    =  
     oBrw1:lNoHScroll  := .T.  //   
  
     oBrw1:lFooting := .T.     //  
     oBrw1:lDrawFooters := .T. //   
     oBrw1:nHeightFoot  := nFontSize*3  //   
     oBrw1:DrawFooters()       //   
  
     oBrw1:nFreeze     := 1     //  
     oBrw1:lLockFreeze := .T.   //      
     
     oBrw1:ResetVScroll()      //   

     IF oBrw1:nLen == 0  //  ,    
        //MsgDebug("Alias=",ALIAS(),"TBROWSE records = 0 !","DbSetFilter=",DBFILTER())
     ENDIF

    // ----------    ----------------
    //oBrw1:bKeyDown := { | nKey | MyKeyAction1(nKey,oBrw1, ThisWindow.Name, 0), lOk := nKey != VK_ESCAPE }
    //oBrw1:bLDblClick:= { || MyAction1(oBrw1, ThisWindow.Name, 0) } //      
  
    //? "Width=",GetProperty(oBrw1:cParentWnd, oBrw1:cControlName, "Width" )
    //? "=",  nBrw1Width
    // ----------     ----------------
    /*IF GetProperty(oBrw1:cParentWnd, oBrw1:cControlName, "Width" ) > nBrw1Width
       SetProperty(oBrw1:cParentWnd, oBrw1:cControlName, "Enabled", .F.) 

       IF oBrw1:lNoVScroll
          nBrw1Width += GetVScrollBarWidth() //   
       ENDIF
       //   , ..     
       _SetControlWidth ( oBrw1:cControlName, oBrw1:cParentWnd, nBrw1Width) 

       SetProperty(oBrw1:cParentWnd, oBrw1:cControlName, "Enabled", .T.)

       oBrw1:Display()
    ENDIF */ 

    oBrw1:Refresh(.T.)
    oBrw1:nCell := 2    //    

    //     
    nBCol   := GetProperty(oBrw1:cParentWnd, "Button_1", "Col")
    nBWidth := GetProperty(oBrw1:cParentWnd, "Button_1", "Width")
    nTbrCol   := GetProperty( oBrw1:cParentWnd, oBrw1:cControlName, "Col" )
    nTbrWidth := GetProperty(oBrw1:cParentWnd, oBrw1:cControlName, "Width" ) 
    IF nBCol + nBWidth < nTbrWidth + nTbrCol
       nWidth2 := nTbrWidth + nTbrCol - ( nBCol ) 
       SetProperty(oBrw1:cParentWnd, "Button_1", "Width",nWidth2)
    ENDIF 
  
RETURN NIL

////////////////////////////////////////////////////////////
//    
FUNCTION MyCreateTableMenu()
    LOCAL cForm := oBrw1:cParentWnd
    LOCAL cMenuFont, cScreen, aTableFont, cFontName, nFontSize

    cFontName := _HMG_DefaultFontName   
    nFontSize := _HMG_DefaultFontSize   

    SET MENUSTYLE STANDARD 

    cMenuFont := "Font: " + cFontName + "  Size: " + HB_NtoS(nFontSize)
    cScreen := "LargeFont() = " + XTOC(LargeFonts()) + CRLF + CRLF
    cScreen += "(" + HB_NtoS(GetDesktopWidth())+"x"+HB_NtoS(GetDesktopHeight()) + ")"
  
    aTableFont := LoadTbrwFonts(oBrw1) //    -> util_Tsbrowse.prg

    //     -   TBROWSE
    DEFINE CONTEXT MENU CONTROL oBrw1
        MENUITEM ": "   + ThisWindow.Name   ACTION { || MsgInfo("Form / : " + ThisWindow.Name) }     	 
        MENUITEM ": " + cScreen             ACTION { || MsgInfo(cScreen)    }                              
        MENUITEM cMenuFont + " /  :" ACTION { || TableInfoFont(cMenuFont,aTableFont) }             	 
        SEPARATOR                                                                                                             	 
        MENUITEM ":  "      ACTION { || TableInfoSuperHeader(oBrw1) } 
        MENUITEM ":   "       ACTION { || TableInfoSize(oBrw1) }        
        MENUITEM ":   "  ACTION { || TableInfoCell(oBrw1) }        
        SEPARATOR                                                                                                             	 
        MENUITEM ":  "           ACTION { || Base_Current()       }  
    END MENU

RETURN NIL

/////////////////////////////////////////////////////////////////////////////////
FUNCTION TblFocus()  
   oBrw1:SetFocus()
   RETURN NIL

////////////////////////////////////////////////////////////
FUNCTION ChangeTable(oBr)
   RETURN On_DrawSele( oBr )

////////////////////////////////////////////////////////////////////////
STATIC FUNCTION On_DrawSele( oBr ) 
   LOCAL cForm := oBrw1:cParentWnd
   LOCAL cFil2 := AllTrim(EVal(oBrw1:GetColumn('FILE2'):bData)) // !!!
   LOCAL lFil2 := Empty(cFil2)

   If ! HB_ISOBJECT(oBr)
      oBr := oBrw1
   EndIf
   
   If _IsControlDefined('Button_Conv', cForm)
      If oBr:nCell != oBr:nColumn('LCONV')
         lFil2 := .F.
      EndIf
      SetProperty(cForm, 'Button_Conv', 'Enabled',   lFil2)
      SetProperty(cForm, 'Button_View', 'Enabled', ! lFil2)
      DoEvents()
   EndIf
   
   RETURN Nil 

////////////////////////////////////////////////////////////////////////
// ------  oBrw1:cToolTip    --------
STATIC FUNCTION On_DrawLine( oBr ) 
   
   If oBr:lPainted 
      oBr:aRowPosRec[ oBr:nPaintRow ] := (oBr:cAlias)->( RecNo() ) 
   EndIf 
   
   RETURN Nil 
 
////////////////////////////////////////////////////////////////////////
// ------  oBrw1:cToolTip    --------
STATIC FUNCTION On_ToolTip( oBr, nCol, nRow ) 
   LOCAL cTxt := '' 
   LOCAL nRec := 0 
   LOCAL cAls := oBr:cAlias 
   LOCAL nOld := (cAls)->( RecNo() ) 
   LOCAL lRow := nRow > 0 .and. nRow <= Len( oBr:aRowPosRec ) 
   LOCAL cFil, cOut, uImg
   LOCAL nCol2 := oBr:nColumn('FILE1')
   LOCAL nCol5 := oBr:nColumn('LCONV')
   LOCAL nCol6 := oBr:nColumn('FILE2')
//   LOCAL cVal, cLbl := "Label_Copyright"
//   LOCAL cLC  := _GetValue( cLbl, oBr:cParentWnd )
   
//   IF ( nAt := AT(":", cLC) ) > 0
//      cLC := Left( cLC, nAt-2 ) 
//   ENDIF
    
   If lRow .and. ( nCol == nCol2 .or. nCol == nCol5 .or. nCol == nCol6 )
      nRec := oBr:aRowPosRec[ nRow ] 
   EndIf 
   
   If nRow == oBr:nRowPos .and. empty(oBr:aRowPosRec[ nRow ])
      oBr:aRowPosRec[ nRow ] := (cAls)->( RecNo() )
      nRec := oBr:aRowPosRec[ nRow ] 
   EndIf

   If nRec > 0 
      (cAls)->( dbGoto( nRec ) ) 
      cFil := AllTrim(Eval(oBr:GetColumn(nCol2):bData)) 
      cOut := AllTrim(Eval(oBr:GetColumn(nCol6):bData)) 
      uImg :=         Eval(oBr:GetColumn(nCol5):bData) //   logical

//      cVal := " : Row/Col= " + HB_NtoS(nRow) + "/" + HB_NtoS(nCol)
//      cVal += "  "+cFil+"/"+cOut + " -> " + HB_NtoS(nImg)
//      _SetValue( cLbl, oBr:cParentWnd, cLC + cVal )

      IF nCol == nCol2 
         cTxt := ' ' + cFil
      ELSEIF nCol == nCol6
         cTxt := IIF( LEN(cOut) > 0, ' '        + cOut, '' )
      ELSEIF nCol == nCol5
         If HB_ISNUMERIC(uImg)
            cTxt := IIF( uImg == 2 , ' ' + cFil, '' ) 
         Else
            cTxt := IIF( ! uImg    , ' ' + cFil, '' ) 
         EndIf
      ENDIF

      (cAls)->( dbGoto( nOld ) ) 
   EndIf 

   RETURN cTxt 

////////////////////////////////////////////////////////////////////////
FUNCTION FieldImageEdit()
   LOCAL nCol := oBrw1:nCell
   LOCAL oCol := oBrw1:aColumns[nCol]
   LOCAL lVal, aRet, lRet := .F.
   LOCAL cFile := AllTrim(EVal(oBrw1:GetColumn('FILE1'):bData)) //  
   LOCAL cFil2 := AllTrim(EVal(oBrw1:GetColumn('FILE2'):bData)) // 

   If ! empty(cFil2) .and. nCol != 2 //  ,     
      RETURN View_File( cFil2 )
   EndIf

   If oCol:lBitMap
      lVal := (oBrw1:cAlias)->( FIELDGET( FIELDNUM(oCol:cName) ) ) // c BITMAP !!!
   Else
      lVal := EVal(oBrw1:GetColumn(oCol:cName):bData)              // c CHECK  !!!
   EndIf

   IF (oBrw1:cAlias)->( RLock() )  

      aRet := ConvertXLS(cFile,M->cPubFindDir)  // Form_convert.prg
      IF LEN(aRet) > 0
         EVal(oBrw1:GetColumn('FILE2'):bData, aRet[1])  //  
         EVal(oBrw1:GetColumn('SIZE2'):bData, aRet[2])  // 
         EVal(oBrw1:GetColumn('DATE2'):bData, aRet[3])  // 
         lRet := .T.
      ENDIF

      If oCol:lBitMap
         (oBrw1:cAlias)->( FIELDPUT(FIELDNUM(oCol:cName), lRet ) ) // c BITMAP !!!
      Else
         EVal(oBrw1:GetColumn(oCol:cName):bData, lRet)               // c CHECK  !!!
      EndIf

      (oBrw1:cAlias)->( DbCommit() )
      (oBrw1:cAlias)->( DbUnlock() )

      oBrw1:DrawSelect()     //  . 
      IF LEN(aRet) > 0
         oBrw1:GoRight()     //   .
         ChangeTable()       // !!!
      ENDIF
      
   ELSE
      MsgInfo(" !")
   ENDIF  

   RETURN NIL

////////////////////////////////////////////////////////////////////////
FUNCTION FieldEditFile()
   LOCAL nCell := oBrw1:nColumn('FILE1')
   LOCAL cFile := AllTrim(EVal(oBrw1:GetColumn( nCell ):bData)) 
   LOCAL cFil2 := AllTrim(EVal(oBrw1:GetColumn('FILE2'):bData)) 

   If ! empty(cFil2) .and. oBrw1:nCell != nCell //  ,              
      cFile := cFil2
   EndIf

   RETURN View_File( cFile )
   
////////////////////////////////////////////////////////////////////
STATIC FUNC View_File( cFile )

   If ! empty(cFile)
      cFile := M->cPubFindDir + "\" + cFile
      If lower(right(cFile, 3)) == 'csv'
         ShellExecute(, "open", "notepad.exe", cFile,, 1 )
      Else
         OpenXLSFile( cFile )
      EndIf
   EndIf

RETURN Nil
   
////////////////////////////////////////////////////////////////////
//   
FUNCTION MyRGB(aDim)
   RETURN RGB(aDim[1],aDim[2],aDim[3])

