/*
 * MINIGUI - Harbour Win32 GUI library 
 *
 * Copyright 2017 Verchenko Andrey <verchenkoag@gmail.com>
 * Copyright 2017 Sergej Kiselev <bilance@bilance.lv>
*/

#include "minigui.ch"
#include "Dbinfo.ch"

FIELD FILE1, SIZE1, DATE1, FILE2, SIZE2, DATE2
/////////////////////////////////////////////////////////////////
FUNCTION Base_Current()
   LOCAL nI, cText, nSel, nOrder, cAlias, cMsg, cPathFile

   cMsg := " : " + ProcName( 1 ) + "(" + hb_ntos( ProcLine( 1 ) ) + ")"
   cMsg += "  --> " + ProcFile( 1 ) + CRLF + CRLF

   cAlias := ALIAS()
   nSel := SELECT()
   IF nSel == 0
      cText := "No open databases !" + CRLF + CRLF + cMsg  
      MsgStop( cText, "Open databases" )
      RETURN NIL
   ENDIF

   nOrder := INDEXORD()  // : NUMBA

   cText := "Open Database - alias: "+Alias()+"()" + CRLF + CRLF
   cText += "Open indexes: " + CRLF + CRLF 
   FOR nI := 1 TO 100
      cPathFile := ALLTRIM( DBORDERINFO(DBOI_FULLPATH,,ORDNAME(nI)) )
      IF cPathFile == ""
         EXIT
      ELSE
         DBSetOrder( nI )
         cText += HB_NtoS(nI)+"-"+cPathFile + " " + CRLF + "Index Focus: " + ORDSETFOCUS() + CRLF 
         cText += "Index key: [" + DBORDERINFO( DBOI_EXPRESSION ) + "]" + CRLF + CRLF
      ENDIF 
   NEXT
   DBSetOrder( nOrder ) // switch to main index
   cText += CRLF + "Current index = "+STR(nOrder,3)+" , Index Focus: " + ORDSETFOCUS() +  CRLF
   MsgInfo( cText, "Open databases" )

   RETURN NIL

////////////////////////////////////////////////////////////
FUNCTION MyCreateDbfDir(cFileDbf,cFindPath)
   LOCAL aDbf, nI, aDim, cMaska, aDimDir, cFile, nSize, dDate
   LOCAL cFile2, nSize2, dDate2, lYes, nJ, aMaska, cFileIndex 
   DEFAULT cFindPath := GetStartUpFolder() 

   aMaska := {"\*.xls", "\*.xlsx"}
   aDim := {}
   FOR nJ := 1 TO LEN(aMaska)
      cMaska := aMaska[nJ]
      //    
      aDimDir := Directory( cFindPath + cMaska )
      IF Len( aDimDir ) > 0
         FOR nI := 1 TO Len( aDimDir )
            cFile := LOWER( aDimDir[ nI, 1 ] )
            nSize := aDimDir[ nI, 2 ]
            dDate := aDimDir[ nI, 3 ]
            cFile2 := cFindPath + "\" + cFile
            cFile2 := ChangeFileExt( cFile2, ".csv"    ) 
            IF FILE(cFile2)
               nSize2 := FileSize( cFile2 ) 
               dDate2 := FileDate( cFile2 ) 
               cFile2 := SUBSTR(cFile2, RAT("\",cFile2)+1)
               lYes := .T.
            ELSE
               cFile2 := "" ; nSize2 := 0 ; dDate2 := CTOD("")
               lYes := .F.
            ENDIF
            AADD( aDim , { cFile, nSize, dDate, cFile2, nSize2, dDate2, lYes } )
         NEXT
      ENDIF
   NEXT

   aDbf := {}
   //AADD( aDbf , {"ID"     ,"+",  8, 0 } )
   AADD( aDbf , {"FILE1"  ,"C", 35, 0 } )
   AADD( aDbf , {"SIZE1"  ,"N", 10, 0 } )
   AADD( aDbf , {"DATE1"  ,"D",  8, 0 } ) 
   AADD( aDbf , {"FILE2"  ,"C", 35, 0 } )
   AADD( aDbf , {"SIZE2"  ,"N", 10, 0 } )
   AADD( aDbf , {"DATE2"  ,"D",  8, 0 } ) 
   AADD( aDbf , {"LCONV"  ,"L",  1, 0 } ) 
                                                                                         
   //                                                   
   DBCreate( cFileDbf, aDbf , "DBFCDX")
   USE ( cFileDbf ) Alias TMP2 CODEPAGE "RU1251" VIA "DBFCDX" NEW EXCLUSIVE
   IF LEN(aDim) > 0
      FOR nI := 1 TO LEN(aDim)
         APPEND BLANK
         TMP2->FILE1 := aDim[nI,1] 
         TMP2->SIZE1 := aDim[nI,2]
         TMP2->DATE1 := aDim[nI,3]
         TMP2->FILE2 := aDim[nI,4]
         TMP2->SIZE2 := aDim[nI,5] 
         TMP2->DATE2 := aDim[nI,6]
         TMP2->LCONV := aDim[nI,7]
      NEXT
   ENDIF
   CLOSE TMP2
   cFileIndex := ChangeFileExt( cFileDbf, ".cdx"  )
   DELETEFILE(cFileIndex)

   RETURN NIL

////////////////////////////////////////////////////////////
FUNCTION MyUseDbfIndex(cFileDbf)
   LOCAL aFile := {}, cFileIndex

   USE ( cFileDbf ) Alias DBMAIN CODEPAGE "RU1251" VIA "DBFCDX" NEW EXCLUSIVE
   If OrdCount() < 1 
      INDEX ON UPPER(FILE1) TAG FILE1 
      INDEX ON STR(SIZE1)   TAG SIZE1  
      INDEX ON DTOS(DATE1)  TAG DATE1 
      INDEX ON UPPER(FILE2) TAG FILE2 
      INDEX ON STR(SIZE2)   TAG SIZE2 
      INDEX ON DTOS(DATE2)  TAG DATE2 
   EndIf 
   OrdSetFocus(1) 
   DbGotop() 

   cFileIndex := ALLTRIM( DBORDERINFO(DBOI_FULLPATH,,ORDNAME(1)) )
   IF LEN(cFileIndex) > 0
      AADD( aFile , cFileIndex )
   ENDIF

   RETURN aFile
